zoukankan      html  css  js  c++  java
  • HDU 1260:Tickets(DP)

    Tickets

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
    Total Submission(s): 7925    Accepted Submission(s): 4032

    Problem Description

    Jesus, what a great movie! Thousands of people are rushing to the cinema. However, this is really a tuff time for Joe who sells the film tickets. He is wandering when could he go back home as early as possible.
    A good approach, reducing the total time of tickets selling, is let adjacent people buy tickets together. As the restriction of the Ticket Seller Machine, Joe can sell a single ticket or two adjacent tickets at a time.
    Since you are the great JESUS, you know exactly how much time needed for every person to buy a single ticket or two tickets for him/her. Could you so kind to tell poor Joe at what time could he go back home as early as possible? If so, I guess Joe would full of appreciation for your help.

    Input

    There are N(1<=N<=10) different scenarios, each scenario consists of 3 lines:
    1) An integer K(1<=K<=2000) representing the total number of people;
    2) K integer numbers(0s<=Si<=25s) representing the time consumed to buy a ticket for each person;
    3) (K-1) integer numbers(0s<=Di<=50s) representing the time needed for two adjacent people to buy two tickets together.

    Output

    For every scenario, please tell Joe at what time could he go back home as early as possible. Every day Joe started his work at 08:00:00 am. The format of time is HH:MM:SS am|pm.

    Sample Input

    2
    2
    20 25
    40
    1
    8
    

    Sample Output

    08:00:40 am
    08:00:08 am

    题意

    n个人排队买票,每次卖票可以卖给一个人,也可以卖给相邻的两个人,卖给一个人所花费的时间为a,卖给两个人花费的时间为b,求这些人全部买到票所需要的最少时间

    思路

    因为是求最少时间,保证每次状态是从第0个人转移来的,给dp[0]赋值为0,dp[1]的值为a[1]

    状态转移方程:dp[i]=min(dp[i-1]+a[i],dp[i-2]+b[i-1])

    AC代码

    #include<bits/stdc++.h>
    #define  ll long long
    #define ms(a) memset(a,0,sizeof(a))
    using namespace std;
    const int maxn=1e6+10;
    int a[maxn];
    int b[maxn];
    int dp[maxn];
    int main()
    {
        int t;
        int n;
        scanf("%d",&t);
        while(t--) {
            ms(a);
            ms(b);
            ms(dp);
            scanf("%d", &n);
            for (int i = 1; i <= n; i++)
                scanf("%d", &a[i]);
            for (int i = 1; i < n; i++)
                scanf("%d", &b[i]);
            dp[0] = 0;
            dp[1] = a[1];
            for (int i = 1; i <= n; i++)
                dp[i] += min(dp[i - 1] + a[i], dp[i - 2] + b[i-1]);
            int h = dp[n] / 3600 + 8;
            int mi = dp[n] / 60 % 60;
            int se = dp[n] % 60;
            printf("%02d:%02d:%02d ", h, mi, se);
            if (h > 12)
                printf("pm
    ");
            else
                printf("am
    ");
        }
        return 0;
    }
  • 相关阅读:
    Linux 磁盘挂载和mount共享
    Socket编程实践(8) --Select-I/O复用
    JavaScript 作用域链图具体解释
    扩展MongoDB C# Driver的QueryBuilder
    Gray Code
    Android网络编程Socket【实例解析】
    设计模式之:代理模式
    LOL英雄联盟代打外挂程序-java实现
    MySQL系列:innodb源代码分析之线程并发同步机制
    linux压缩打包
  • 原文地址:https://www.cnblogs.com/Friends-A/p/10324387.html
Copyright © 2011-2022 走看看